config/routes.rb
Rails.application.routes.draw do

  # Authentication
  get 'auth/:provider/callback', to: 'sessions#create'
  get 'auth/failure', to: redirect('/')
  get 'signout', to: 'sessions#destroy', as: 'signout'
  resources :sessions, only: [:create, :destroy]

  # Homepages
  root 'home#logged_in'
  get 'authenticate', to: 'home#logged_out'
  resource :home, only: [:logged_in, :logged_out]

  # Admin
  get :admin, to: 'admin#home'

  # Users
  resources :users do
    put :organization_enable, :organization_disable, :organization_enable_all, :organization_disable_all
  end

  # User roles
  resources :user_roles

  # Roles
  resources :roles

  # Organizations
  resources :organizations do
    put :organization_enable_all, :organization_disable_all
    put :start_rush, :end_rush
    put :archive_hours, :hours_csv
  end

  # Late Plates
  resources :late_plates

  # Meals
  resources :meals

  # Announcements
  resources :announcements

  # Maintenance Requests
  resources :maintenance_requests do
    put :change_started_status, :change_finished_status
  end
  resources :maintenance_request_comments

  # Service Hours
  resources :service_hours do
    get :admin, on: :collection
    get :show_user
    get :hours_pdf
    put :approve_hours, :disapprove_hours
  end

  # Rush
  resources :rushees do
    get :admin, on: :collection
    get :slideshow
    put :vote_yes, :vote_no, :contact_volunteer, :add_visit
  end
  resources :rushee_comments
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def logged_in
    skip_authorization

    unless current_user
      redirect_to authenticate_path
    end

    # Grabs late plates
    @late_plates = LatePlate.where(user_id: current_user&.id).where(organization_id: current_user&.affiliated_organization).limit(3)

    # Grabs announcements
    @announcements = policy_scope(Announcement).where(organization_id: current_user&.affiliated_organization).limit(5).order(id: :desc)

    # Grabs maintenance requests
    @maintenance_requests = policy_scope(MaintenanceRequest).where(organization_id: current_user&.affiliated_organization).limit(3).order(priority_id: :desc)

    # Grabs service hours
    @service_hours = policy_scope(ServiceHour).where(recipient_id: current_user&.id).where(service_hour_status: 2)
    @total_hours = 0
    @service_hours&.each do |counting|
      @total_hours = @total_hours + counting.hours_and_money
    end

    # Grabs org for rush
    if current_user&.affiliated_organization
      @organization = Organization.find(current_user&.affiliated_organization)
    end
  end

  def logged_out
    skip_authorization
  end
end

app/helpers/home_helper.rb
module HomeHelper
end

app/views/home/logged_in.html.erb
<%= render 'layouts/header' %>

<div class="ui container grid" >

  <% if !current_user&.affiliated_organization and !current_user&.enabled %>

    <div class="ui container segment">
      <h1 class="ui center aligned header">
        Welcome to House Manager!
      </h1>
      <p>
        It appears that you currently are not affiliated with an organization. To do so, go to user options and select your organization from the dropdown. Once your organization manager adds you, you'll be all set!
      </p>
    </div>

  <% else  %>

  <% if @organization.in_rush? %>

    </br>
    <div class="ui container segment">
      <div class="row" style="text-align:center;">
        <h3>Your organization is currently in rush. Click the button to go to the rush panel.</h3>
      </div>
      </br>
      <%= link_to "Rush Panel", admin_rushees_path(), class:"ui fluid green button" %>
    </div>

  <% end %>

  <div class="row">
    <div class="four wide column">
      <div class="ui segment">
        <div class="ui center aligned header">
          Upcoming Late Plates
        </div>
        <% if @late_plates&.count > 0 %>
          <div class="ui bulleted list">
          <% @late_plates.each do |late_plate| %>
            <div class="item">
              <%= late_plate.full_name %>
            </div>
          <% end %>
          </div>
        <% else %>
        <div class="item">
          You have no upcoming late plates.
        </div>
        <% end %>
      </div>

      <% if current_user.has_role?(Role.where(label: ['Organization Manager', 'House Manager'])) %>

      <div class="ui segment">
        <div class="ui center aligned header">
          Maintenance Requests
        </div>
        <div class="ui list">
          <% if @maintenance_requests&.count > 0 %>
            <% @maintenance_requests.each do |request| %>
              <div class="item">
                <% if request.priority_id == 1 %>
                  <%= link_to maintenance_request_path(request) do %>
                    <div class="ui fluid green label" align="center">
                      <%= request.issue_title %>
                    </div>
                  <% end %>
                <% elsif request.priority_id == 2 %>
                  <%= link_to maintenance_request_path(request) do %>
                    <div class="ui fluid yellow label" align="center">
                      <%= request.issue_title %>
                    </div>
                  <% end %>
                <% elsif request.priority_id == 3 %>
                  <%= link_to maintenance_request_path(request) do %>
                    <div class="ui fluid orange label" align="center">
                      <%= request.issue_title %>
                    </div>
                  <% end %>
                <% else %>
                  <%= link_to maintenance_request_path(request) do %>
                    <div class="ui fluid red label" align="center">
                      <%= request.issue_title %>
                    </div>
                  <% end %>
                <% end %>
              </div>
            <% end %>
          <% end %>
        </div>
      </div>

      <% end %>

      <div class="ui segment">
        <div class="ui center aligned header">
          Service Hours
        </div>
        <div class="ui indicating progress" data-value=<%= @total_hours.round(2) %> data-total=10>
          <div class="bar">
            <div class="progress"></div>
          </div>
          <div class="label">Total Hours</div>
        </div>
      </div>
    </div>

    <div class="twelve wide column">
      <div class="ui segment">
        <h1 class="ui center aligned header">
          Announcements
        </h1>

        <div class="ui feed">
          <% if @announcements&.count > 0 %>
            <% @announcements.each do |announcement| %>
              <div class="event">
                <div class="label">
                  <%= image_tag announcement.author_image %>
                </div>
                <div class="content">
                  <div class="summary">
										<%= announcement.author_name%> posted '<%= link_to announcement.title, announcement %>'
										<div class="date">
									    <%= time_ago_in_words(announcement.created_at) %> ago on <%= announcement.post_date %>
								    </div>
									</div>
                  <div class="ui segment">
                    <%= markdown(announcement.body) %>
                  </div>
                  <div class="ui equal width grid">
                    <div class="row">
                      <% if policy(announcement).update? %>
                        <div class="column">
                          <%= link_to "Edit Announcement", edit_announcement_path(announcement), class:"ui green fluid button" %>
                        </div>
                      <% end %>
                      <% if policy(announcement).destroy? %>
                        <div class="column">
                        <%= link_to "Delete Announcement", announcement_path(announcement), method: :delete, class:"ui red fluid button" %>
                        </div>
                      <% end %>
                    </div>
                  </div>
                </div>
              </div>
              <div class="ui divider"></div>
            <% end %>
          <% else %>

            <div class="ui center aligned segment">
              <strong>No Announcements</strong>
            </div>

          <% end %>
          </br>
          <div class="ui equal width grid">
            <div class="row">
              <div class="column">
                <%= link_to "See more announcements", announcements_path(), :class => "ui primary fluid button" %>
              </div>
              <div class="column">
                <%= link_to "Make new announcement", new_announcement_path(), :class => "ui green fluid button" %>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

  <% end %>

</div>

<%= render 'layouts/footer' %>

app/views/home/logged_out.html.erb
<%= render 'layouts/header' %>

<div class="ui container segment">
  <h1 class="ui center aligned header">
    You are not logged in.
  </h1>
  <h3 class="ui center aligned header">
    Please sign in to continue
  </h3>
  <%= link_to "/auth/google_oauth2", :class=> "ui google plus fluid button" do %>
  <i class="google plus icon"></i>
  <% end %>

</div>

<%= render 'layouts/footer' %>